Index: nQuestLog/modules/Comments.lua
===================================================================
--- nQuestLog/modules/Comments.lua (revision 43390)
+++ nQuestLog/modules/Comments.lua (working copy)
@@ -124,6 +124,8 @@
 	--self.questid = questid
 	if questid and LightHeaded and LightHeaded.IterateQuestComments and nQuestLog:IsModuleEnabled("DetailsFrame") then
 		self:ScheduleEvent(self.Update, 0, self) --Schedule an event because tablet bugs out otherwise.
+		self.altTitle = ''
+		self.altLevel = nil
 	end
 end
 
@@ -166,12 +168,20 @@
 			if LightHeaded:LoadNPCData(id) then                                                                                                                                                                                                                                                                                                                                                                                                                                                
 				for c,z,x,y in LightHeaded:IterateNPCLocs(id) do                                                                                                                                                                                                                          
 					dlink =
-					cat:AddLine('text', '|cFF0066FF['..x..', '..y..']|r', 'func', function() LightHeaded:OnHyperlinkClick(nil, "lhref:zcoord:"..c..":"..z..":"..x..":"..y..":"..name); end, 'indentation', 10)                                                                                                                                                                                                                                                                             
+					cat:AddLine('text', '|cFF0066FF['..x..', '..y..']|r', 'func', function() LightHeaded:OnHyperlinkClick(nil, "lhref:zcoord:"..c..":"..z..":"..x..":"..y..":"..name); end, 'justify', 'CENTER')
 				end                                                                                                                                                                                                                                                                                                                                                                                                                                                                              
 			else                                                                                                                                                                                                                                                                                                                                                                                                                                                                               
-				cat:AddLine('text', 'Location unknown', 'indentation', 10)                                                                                                                                                                                                                                                                                                                                                                                                                       
+				cat:AddLine('text', 'Location unknown', 'justify', 'CENTER')
 			end                                                                                                                                                                                                                                                                                                                                                                                                                                                                                
 		end                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  
+		local function showAltQuest(id)
+			local name = ''
+			local lvl = nil
+			name,lvl = LightHeaded:QIDToTitleLevel(id)
+			self.altTitle = name
+			self.altLevel = tonumber(lvl)
+			self.detailsFrameQID = nQuestLog:GetModule("DetailsFrame").questid
+		end
 		tablet:Register('nQuestLog_Comments', 'detachedData', self.db.profile.data, 'cantAttach', true, 'dontHook', true,
 			'hideWhenEmpty', true, 'showTitleWhenDetached', true, 'strata', 'HIGH', 'minWidth', self.db.profile.minWidth, 'maxHeight',self.db.profile.maxHeight,
 			'children', function()
@@ -179,40 +189,80 @@
 				-- Much of this was taken from LightHeaded itself.
 				if questid  and LightHeaded and LightHeaded.IterateQuestComments then
 					local title, level, tag = quixote:GetQuestById(questid)
-					local qid,sharable,_,reqlev,stype,sname,sid,etype,ename,eid,exp,rep = LightHeaded:GetQuestInfo(title, level)
+					local qid,sharable,_,reqlev,stype,sname,sid,etype,ename,eid,exp,rep,series = LightHeaded:GetQuestInfo(title, level)
+					if self.detailsFrameQID ~= nQuestLog:GetModule("DetailsFrame").questid then
+						self.altTitle = ''
+						self.altLevel = nil
+					end
+					if self.altTitle ~= '' and self.altLevel ~= nil then
+						qid,sharable,_,reqlev,stype,sname,sid,etype,ename,eid,exp,rep,series = LightHeaded:GetQuestInfo(self.altTitle, self.altLevel)
+						title = self.altTitle
+						level = self.altLevel
+					end
 					--local color = GetDifficultyColor(level)
 					tablet:SetTitle("Comments")
 					--tablet:SetTitleColor((color and color.r) or 1, (color and color.g) or 1, (color and color.b) or 1)
 
 					local cat = tablet:AddCategory('text', 'LightHeaded Info', 'columns', 1, 'wrap', true, 'justify', 'CENTER')
 
-					cat:AddLine('text', 'Quest ID: |cffffffff'..qid, 'func', urlClick, 'arg1', 'http://www.wowhead.com/?quest='..qid)
-					cat:AddLine('text', 'Shareable: |cffffffff'..(shareable and 'Yes' or 'No'))
-					cat:AddLine('text', 'Level: |cffffffff'..level)
-					if reqlev ~= '' then cat:AddLine('text', 'Required Level: |cffffffff'..reqlev) end
+					cat:AddLine('text', '|cFF66FF66['..level..'] '..title, 'justify', 'CENTER')
+					if sharable ~= '' and reqlev ~= '' then
+						cat:AddLine('text', 'Quest ID |cffffffff'..qid..'|cffffd100 - Req Lvl |cffffffff'..reqlev..'|cffffd100 - |cffffffffSharable', 'func', urlClick, 'arg1', 'http://www.wowhead.com/?quest='..qid, 'justify', 'CENTER')
+					elseif sharable ~= '' then
+						cat:AddLine('text', 'Quest ID |cffffffff'..qid..'|cffffd100 - |cffffffffSharable', 'func', urlClick, 'arg1', 'http://www.wowhead.com/?quest='..qid, 'justify', 'CENTER')
+					elseif reqlev ~= '' then
+						cat:AddLine('text', 'Quest ID |cffffffff'..qid..'|cffffd100 - Req Lvl |cffffffff'..reqlev, 'func', urlClick, 'arg1', 'http://www.wowhead.com/?quest='..qid, 'justify', 'CENTER')
+					else
+						cat:AddLine('text', 'Quest ID |cffffffff'..qid, 'func', urlClick, 'arg1', 'http://www.wowhead.com/?quest='..qid, 'justify', 'CENTER')
+					end
 					if stype ~= '' and sname ~= '' then
 						if stype=='npc' then
-							cat:AddLine('text', 'Starts: |cFF0066FF['..sname..']|r', 'func', npcClick, 'arg1', sid) end
+							cat:AddLine('text', 'Starts: |cFF0066FF['..sname..']|r', 'func', npcClick, 'arg1', sid, 'justify', 'CENTER') end
 						else
-							cat:AddLine('text', 'Starts: |cffffffff'..sname)
+							cat:AddLine('text', 'Starts: |cffffffff'..sname, 'justify', 'CENTER')
 						end
 					if sid == self.npcid then addNpcLocs(cat, sid, sname) end
 					if etype ~= '' and ename ~= '' then
 						if etype == 'npc' then
-							cat:AddLine('text', 'Ends: |cFF0066FF['..ename..']|r', 'func', npcClick, 'arg1', eid) end
+							cat:AddLine('text', 'Ends: |cFF0066FF['..ename..']|r', 'func', npcClick, 'arg1', eid, 'justify', 'CENTER') end
 						else
-							cat:AddLine('text', 'Ends: |cffffffff'..ename)
+							cat:AddLine('text', 'Ends: |cffffffff'..ename, 'justify', 'CENTER')
 						end
 					if eid == self.npcid then addNpcLocs(cat, eid, ename) end
-					if exp ~= '' then cat:AddLine('text', 'Experience: |cffffffff'..exp) end
+					if exp ~= '' then cat:AddLine('text', '|cffffffff'..exp..' |cffffd100experience', 'justify', 'CENTER') end
+
 					if rep ~= '' then
 						-- Might want to do an inline category here with columns...
-						cat:AddLine('text', 'Reputation:')
-						for name,value in rep:gmatch("([^\031]+)\031([^\031]+)") do
-							cat:AddLine('text', '|cffffffff' .. name .. ' - ' .. value, 'indentation', 10)
+						for name,value in rep:gmatch("([^\029]+)\029([^\029]+)") do
+							cat:AddLine('text', name..'|r: |cffffffff'..value..' |cffffd100rep', 'justify', 'CENTER')
 						end
 					end
-					
+					if series ~= '' then
+						cat:AddLine('text', '\n|cffffffffLightHeaded Quest Series|r', 'justify', 'CENTER')
+
+						for step,id in series:gmatch("([^\029]+)\029([^\029]+)") do
+							local name = ''
+							local lvl = ''
+
+							if not LH_QuestData then
+								name = "Quest " .. id
+								LoadAddOn("LightHeaded_Quest_Data")
+							else
+								id = tonumber(id)
+								name,lvl = LightHeaded:QIDToTitleLevel(id)
+							end
+
+							local link
+							if LightHeaded:KeyMatchQID(title, level, id) then
+								link = "["..lvl.."] "..name
+							else
+								link = "|cFF66FF66["..lvl.."] "..name
+							end
+
+							cat:AddLine('text', link, 'func', showAltQuest, 'arg1', id, 'justify', 'CENTER')
+						end
+					end
+
 					cat = tablet:AddCategory('text', 'LightHeaded Comments', 'columns', 1, 'wrap', true, 'justify', 'CENTER')
 					if LightHeaded:GetNumQuestComments(title, level) then
 						for idx, qid, cid, rating, indent, parent, date, poster, comment in LightHeaded:IterateQuestComments(title, level) do