Index: healthbar.lua
===================================================================
--- healthbar.lua	(revision 101)
+++ healthbar.lua	(working copy)
@@ -42,11 +42,17 @@
   local UnitClass = UnitClass
   local UnitReactionColor = UnitReactionColor
   local UnitReaction = UnitReaction
+  local UnitInParty = UnitInParty
+  local UnitInRaid = UnitInRaid
+  local CheckInteractDistance = CheckInteractDistance
   local RAID_CLASS_COLORS = RAID_CLASS_COLORS
   
   local health = rUnits.colors.health
   local min, max, bar, color
-  
+
+  local banzaiColor = { r = 1, g = 0, b = 0 }
+  local banzai = LibStub("LibBanzai-2.0", true)
+
   function rUnits:UpdateHealth(unit)
   	if(self.unit ~= unit) then return end
   
@@ -56,11 +62,13 @@
   
   	bar:SetMinMaxValues(0, max)
   	bar:SetValue(min)
-  
+
     if(unit == "pet" and GetPetHappiness()) then
 			color = happiness[GetPetHappiness()]
 		elseif(UnitIsTapped(unit) and not UnitIsTappedByPlayer(unit) or not UnitIsConnected(unit)) then
 			color = health[1]
+		elseif banzai and banzai:GetUnitAggroByUnitName(UnitName(unit)) then
+			color = banzaiColor
 		else
 			--color = UnitIsPlayer(unit) and RAID_CLASS_COLORS[select(2, UnitClass(unit))] or UnitReactionColor[UnitReaction(unit, "player")]
 			color = health[2]
@@ -87,8 +95,9 @@
   	--end
   	
   	if UnitIsPlayer(unit) then
-  	  local color = UnitIsPlayer(unit) and RAID_CLASS_COLORS[select(2, UnitClass(unit))]
-  	  bar.value:SetTextColor(color.r, color.g, color.b) 
+	  local class = select(2, UnitClass(unit))
+  	  local color = RAID_CLASS_COLORS[class or "WARRIOR"]
+  	  bar.value:SetTextColor(color.r, color.g, color.b)
   	end
   	
   	if(UnitIsDead(unit)) then
@@ -113,7 +122,11 @@
   			bar.value:SetText(max)
   		end
   	elseif(UnitIsPlayer(unit)) then
- 	    bar.value:SetText(min.." . "..d.."%")
+        if min == d then
+            bar.value:SetText(d.."%")
+        else
+ 	        bar.value:SetText(min.." . "..d.."%")
+        end
   	else
       bar.value:SetText(d.."%")
   	end
Index: layout.lua
===================================================================
--- layout.lua	(revision 101)
+++ layout.lua	(working copy)
@@ -26,6 +26,8 @@
     end
   end
   
+  local banzai = LibStub("LibBanzai-2.0", true)
+
   local func = function(settings, self, unit)
     self.numBuffs = 36
     self.menu = menu
@@ -47,6 +49,13 @@
     }
     self:SetBackdropColor(0, 0, 0, 1)
   
+	banzai:RegisterCallback(function(aggro, name)
+        if UnitExists(self.unit) and UnitName(self.unit) == name then
+            self:UpdateHealth()
+            self:UpdatePower()
+        end
+    end)
+
     local hp = CreateFrame"StatusBar"
     hp:SetHeight(22)
     hp:SetStatusBarTexture(tex)
@@ -94,7 +103,24 @@
     pp.value = ppp
     pp.bg = ppbg
     self.Power = pp
-  
+
+    local oU = self:GetScript("OnUpdate")
+    local total = 0
+    self:SetScript("OnUpdate", function(self, elapsed, ...)
+        total = total + elapsed
+        if total > 1 then
+            if self.unit and UnitExists(self.unit) then
+                if not CheckInteractDistance(self.unit, 1) then
+                    self:SetAlpha(0.3)
+                else
+                    self:SetAlpha(1)
+                end
+            end
+            total = 0
+        end
+        if oU then oU(self, elapsed, ...) end
+    end)
+
     local name = hp:CreateFontString(nil, "OVERLAY")
     name:SetPoint("LEFT", hp, 3, 0)
     name:SetPoint("RIGHT", ppp, "LEFT")
Index: name.lua
===================================================================
--- name.lua	(revision 101)
+++ name.lua	(working copy)
@@ -71,11 +71,11 @@
     end
     
   	if(UnitIsDead(unit)) then
-  		self.Name:SetTextColor(0.6, 0.6, 0.6)
+  		self.Name:SetTextColor(1, 0, 0)
   	elseif(UnitIsGhost(unit)) then
-  		self.Name:SetTextColor(0.6, 0.6, 0.6)
+  		self.Name:SetTextColor(1, 0, 0)
   	elseif(not UnitIsConnected(unit)) then
   		self.Name:SetTextColor(0.6, 0.6, 0.6)
   	end
     
-  end
\ No newline at end of file
+  end
Index: powerbar.lua
===================================================================
--- powerbar.lua	(revision 101)
+++ powerbar.lua	(working copy)
@@ -79,26 +81,6 @@
   	  local color = UnitIsPlayer(unit) and RAID_CLASS_COLORS[select(2, UnitClass(unit))]
   	  bar.value:SetTextColor(color.r, color.g, color.b) 
   	end
-    
-  	if(min < 0) then
-  		bar.value:SetText()
-  	elseif(UnitIsDead(unit)) then
-  		bar.value:SetText()
-  	elseif(UnitIsGhost(unit)) then
-  		bar.value:SetText()
-  	elseif(not UnitIsConnected(unit)) then
-  		bar.value:SetText()
-  	elseif(unit == "player") then
-      local c = max - min
-      bar.value:SetText(min.." . ")
-    else
-  		local c = max - min
-  		if(c > 0) then
-  			bar.value:SetText(max-c.." | ")
-  		else
-  			bar.value:SetText(max.." | ")
-  		end
-  	end
-        
+    bar.value:SetText()
   
   end
Index: rUnits.toc
===================================================================
--- rUnits.toc	(revision 101)
+++ rUnits.toc	(working copy)
@@ -2,6 +2,7 @@
 ## Author: Rothar
 ## Title: rUnits
 ## Notes: simple unitframes
+## OptionalDeps: LibBanzai-2.0
 
 core.lua
 
@@ -16,4 +17,4 @@
 icons.lua
 leader.lua
 
-layout.lua
\ No newline at end of file
+layout.lua